function rate = lpcvg(sol,p)

Nvals = 10*2.^(1:9);
errors = zeros(1,9);

for i = 1:9
    mesh = linspace(0,1,Nvals(i)+1)';
    h = 1/Nvals(i);

    U = l2proj_tent(mesh, sol);

    qpts = sort([mesh(1:end-1) + h/2 - h/(2*sqrt(3)); mesh(1:end-1) + h/2 + h/(2*sqrt(3))]);
    appr = linterp(mesh, U, qpts);
    ex = sol(qpts);
    
    if(p~=0)
        errors(i) = (sum(abs((appr-ex')).^p)*(h/2)).^(1/p);
    else
        errors(i) = max(abs(appr(:)-ex(:)));
    end

end

loglog(Nvals,errors)
hold on
pol = polyfit(log(Nvals), log(errors), 1);
rate=-pol(1);
